﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class Boat : MonoBehaviour {

    private Rigidbody2D rigidBody;
    private int secondsLastSound = 0;

	// Use this for initialization
	void Start () {
        this.rigidBody = this.GetComponent<Rigidbody2D>();
    }
	
	// Update is called once per frame
	void Update () {
        secondsLastSound++;
        this.rigidBody.AddForce(new Vector2(-this.transform.position.x * 10, 0));
    }

    void OnTriggerStay2D(Collider2D other)
    {
        float positionDifference = (this.transform.position.y - other.transform.position.y);
        this.rigidBody.AddForceAtPosition(
            new Vector2(0, (float)Math.Pow(positionDifference, 1.2)/ 2),
            new Vector2(other.transform.position.x + other.transform.localScale.x, other.transform.position.y));
    }

    void OnCollisionEnter2D(Collision2D coll)
    {
        if(secondsLastSound>=30 && coll.gameObject.name == "fish(Clone)")
        {
            AudioSource audio = GetComponent<AudioSource>();
            audio.Play();
            secondsLastSound = 0;
        }
    }
}
