﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CloudSpawner : MonoBehaviour {
	public GameObject[] clouds;   
	public int cloudCount = 40;
	public float minVelocity = 10;
	public float maxVelocity = 100;
	private Bounds bound;

	void Start () {
		for (int i = 0; i < cloudCount; i++) {
			bound = GetComponent<BoxCollider2D> ().bounds;
			var xRange = Random.Range (bound.center.x - bound.size.x / 2, bound.center.x + bound.size.x / 2);
			var yRange = Random.Range (bound.center.y - bound.size.y / 2, bound.center.y + bound.size.y / 2);

			// Random position within this transform
			var postitio = new Vector3(xRange, yRange, 1);
			var instance = (GameObject)Instantiate(clouds[Random.Range (0, clouds.Length)], postitio, transform.rotation);     
			instance.GetComponent<Rigidbody2D> ().AddForce (Vector2.right * Random.Range (minVelocity, maxVelocity));
			//Attach as child
			instance.transform.parent = gameObject.transform;
		}
	}

	// Update is called once per frame
	void Update () {
		for (int i = 0; i < cloudCount; i++) {
			var cloud = gameObject.transform.GetChild (i);
			if (cloud.transform.position.x > bound.center.x + bound.size.x / 2) {
				cloud.transform.position = new Vector3 (bound.center.x - bound.size.x / 2, cloud.transform.position.y, cloud.transform.position.z);
			}
		}
	}
}
