﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class FishAi : MonoBehaviour {

	private GameObject target;   
	private Vector3 targetPoint;
	private Quaternion targetRotation;
	private float initializationTime;
	private Vector3 attackVector = Vector3.zero;
	private bool launched = false;
	public float speedRotate = 5f;
	public float attackSpeed = 15000f;


	// Use this for initialization
	void Start () {
		Player[] players = PlayerManager.Instance.players;
		List<GameObject> activePlayers = new List<GameObject> ();
		for (int i = 0; i < players.Length; i++) {
			if (players[i].active && !players[i].isDead) {
				activePlayers.Add (players[i].gameObject);
			}
		}

		if (activePlayers.Count == 0) {
			Destroy (gameObject);
		} else {
			target = activePlayers[Random.Range (0, activePlayers.Count)];
		}

		initializationTime = Time.timeSinceLevelLoad;
	}
	
	// Update is called once per frame
	void Update () {
		if (!target) {
			Destroy (gameObject);
		} else {
			float timeSinceInitialization = Time.timeSinceLevelLoad - initializationTime;
			if (attackVector != Vector3.zero) {
	            var body = GetComponent<Rigidbody2D>();
	            if (!launched) {
					launched = true;
					body.constraints = RigidbodyConstraints2D.None;
					body.AddForce (attackVector.normalized * attackSpeed);
					var collider = GetComponent<BoxCollider2D> ();
					collider.enabled = true;
				}
				if (body.transform.position.y < -500) {
					Destroy (gameObject);
				}
				return;
			}
			if (timeSinceInitialization < 2) {
				Vector3 vectorToTarget = target.transform.position - transform.position;
				float angle = Mathf.Atan2 (vectorToTarget.y, vectorToTarget.x) * Mathf.Rad2Deg;
				Quaternion q = Quaternion.AngleAxis (angle, Vector3.forward);
				transform.rotation = Quaternion.Slerp (transform.rotation, q, Time.deltaTime * speedRotate);
			} else {
				attackVector = target.transform.position - transform.position;
			}
		}
	}
}
