﻿using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityStandardAssets._2D;

public class GameManager : MonoBehaviour {
	public GameObject playerEntity;
	public GameObject fishSpawnEntity;
	public Text messageText;
	public string startMessage = "Try staying on the Boat";

	// Use this for initialization
	void Start () {
		Invoke ("SpawnPlayers", 0);

		Player[] players = PlayerManager.Instance.players;
		for (int i = 0; i < players.Length; i++) {
			players [i].isDead = false;
		}

		messageText.text = "Try staying on the Boat";
		Invoke ("ClearText", 5);
	}

	// Update is called once per frame
	void Update () {
		if (Input.GetKey ("escape")) {
			Application.Quit();
		}
	}


	void ClearText() {
		if (messageText.text == startMessage) {
			messageText.text = "";
		}
	}

	void SpawnPlayers() {
		Player[] players = PlayerManager.Instance.players;

		int activePlayers = 0;
		for (int i = 0; i < PlayerManager.Instance.players.Length; i++) {
			if (PlayerManager.Instance.players [i].active) {
				activePlayers += 1;
			}
		}
		List<int> spawnPositions = new List<int>();
		if (activePlayers % 2 == 1) {
			spawnPositions.Add (0);
		}
		spawnPositions.Add (-1);
		spawnPositions.Add (1);
		spawnPositions.Add (2);
		spawnPositions.Add (-2);

		for (int index = 0; index < players.Length; index++) {
			if (players [index].active) {
				GameObject playerObj = Instantiate (playerEntity, new Vector2(spawnPositions[index], 3), Quaternion.identity);
				playerObj.tag = "Player";
				Platformer2DUserControl userControl = playerObj.GetComponent<Platformer2DUserControl> ();
				userControl.index = index;

				PlayerTrackingInfo playerInfo = playerObj.GetComponent<PlayerTrackingInfo> ();
				playerInfo.index = index;

				SpriteRenderer playerRenderer = playerObj.GetComponent<SpriteRenderer> ();
				playerRenderer.material.SetColor("_Color1out", players [index].color);

				PlayerManager.Instance.players [index].gameObject = playerObj;
			}
		}
	}
}
