﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class MenuManager : MonoBehaviour {
	public GameObject[] playerSlots;

	// Use this for initialization
	void Start () {
		Player[] players = PlayerManager.Instance.players;

		for (int i = 0; i < players.Length; i++) {
			playerSlots [i].GetComponent <PlayerStatusToggle> ().color = players [i].color;
		}
	}
	
	// Update is called once per frame
	void Update () {
		if (Input.GetKey ("escape")) {
			Application.Quit();
		}
		Player[] players = PlayerManager.Instance.players;
		if (Input.GetButton ($"P1-Start")) {
			// Ensure at least one player
			bool canStart = false;
			for (int index = 0; index < players.Length; index++) {
				if (players [index].active) {
					canStart = true;
					break;
				}
			}
			if (canStart) {
				this.GameStart ();
			}
		}

		for (int index = 0; index < players.Length; index++) {
			if (Input.GetButton ($"P{index + 1}-Jump")) { 
				players [index].active = true;
			} else if (Input.GetButton ($"P{index + 1}-Cancel")) { 
				players [index].active = false;
			}

			playerSlots [index].GetComponent <PlayerStatusToggle> ().active = players [index].active;
		}
	}

	void GameStart () {
		SceneManager.LoadScene ("Scenes/Ocean");
	}
}
