using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class Restarter : MonoBehaviour {
	public Text messageText;

    private void OnTriggerEnter2D(Collider2D other) {
        if (other.tag == "Player") {
			Destroy (other);
			PlayerTrackingInfo playerInfo = other.GetComponent<PlayerTrackingInfo> ();

			Player[] players = PlayerManager.Instance.players;

			players [playerInfo.index].isDead = true;

			Debug.Log ($"Player {playerInfo.index} died.");
			messageText.text = $"Player {playerInfo.index + 1} died.";
			Invoke ("ClearText", 5);

			bool allDead = true;
			for (int i = 0; i < players.Length; i++) {
				if (players[i].active && !players [i].isDead) {
					allDead = false;
					break;
				}
			}

			if (allDead) {
				Debug.Log ("All players dead.");
				SceneManager.LoadScene ("Scenes/HighScores");
			}
        }
    }

	void ClearText() {
		messageText.text = "";
	}
}
