﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WaveGeneration : MonoBehaviour {

    public GameObject wave;
    private Wave lastWave;
    public float maxWaveHeight = -27;
    public float minWaveHeight = -29;
    public float maxMaxWaveHeight = -27;
    public float minMinWaveHeight = -29;
    public int time = 0;
    private float waveMovementDown = -0.05f;
    private float waveMovementUp = 0.1f;

    // Use this for initialization
    void Start () {
        for (int i = -400; i <= 340; i++)
        {
           GameObject lastWaveObject = Instantiate(wave, new Vector3((float)i/10, -28f + Mathf.Sin((float)i/20), 0), Quaternion.identity);
			lastWaveObject.transform.parent = transform;
            if(this.lastWave != null)
            {
                Wave currentWave = lastWaveObject.GetComponent<Wave>();
                currentWave.leftWave = this.lastWave;
            }
           this.lastWave = lastWaveObject.GetComponent<Wave>();
        }
	}
	
	// Update is called once per frame
	void Update () {
        this.time++;
        Wave currentWave = lastWave;
        float speedHeightAdaption = 0.01f;

        if (time % 300 == 0)
        {
            this.maxMaxWaveHeight = -27 + Random.Range(0, Mathf.Pow(time, 0.5f) / 10);
            this.minMinWaveHeight = -29 - Random.Range(0, Mathf.Pow(time, 0.5f) / 10);
        }
        if(this.maxWaveHeight < this.maxMaxWaveHeight)
        {
            this.maxWaveHeight += speedHeightAdaption;
        } else
        {
            this.maxWaveHeight -= speedHeightAdaption;
        }
        if(this.minWaveHeight < this.minMinWaveHeight)
        {
            this.minWaveHeight += speedHeightAdaption;
        } else
        {
            this.minWaveHeight -= speedHeightAdaption;
        }

        float lastWaveHeight = 0;
        while (currentWave != null)
        {
            if(currentWave == lastWave)
            {
                if (currentWave.gettingDown)
                {
                    if (currentWave.transform.position.y <= this.minWaveHeight)
                    {
                        currentWave.gettingDown = false;
                    }
                    currentWave.transform.Translate(new Vector3(0, this.waveMovementDown, 0));
                }
                else
                {
                    if (currentWave.transform.position.y >= this.maxWaveHeight)
                    {
                        currentWave.gettingDown = true;
                    }
                    currentWave.transform.Translate(new Vector3(0, this.waveMovementUp, 0));
                }
            } else
            {
                if (currentWave.gettingDown)
                {
                    if (currentWave.transform.position.y <= this.minWaveHeight)
                    {
                        currentWave.gettingDown = false;
                    }
                    currentWave.transform.position = new Vector3(
                                        currentWave.transform.position.x,
                                        (lastWaveHeight
                                        + currentWave.transform.position.y + Mathf.Min(this.waveMovementDown * (this.minWaveHeight - currentWave.transform.position.y), -0.01f)
                                        + Random.Range(-0.1f, 0.1f))
                                        / 2,
                                        0
                                        );
                    currentWave.transform.Translate(new Vector3(0, waveMovementDown, 0));
                }
                else
                {
                    if (currentWave.transform.position.y >= this.maxWaveHeight)
                    {
                        currentWave.gettingDown = true;
                    }
                    currentWave.transform.position = new Vector3(
                                        currentWave.transform.position.x,
                                        (lastWaveHeight
                                        + currentWave.transform.position.y + Mathf.Min(this.waveMovementUp * (this.maxWaveHeight - currentWave.transform.position.y), 0.01f)
                                        + Random.Range(-0.1f, 0.1f))
                                        / 2,
                                        0
                                        );
                }
            }

            lastWaveHeight = currentWave.transform.position.y;
            currentWave = currentWave.leftWave;
        }
	}
}
